<template>
  <div>
    <v-row>
      <v-col>
        <p>
          The anchor <span v-katex="'\\mathrm{rt}'" /> of the test note
          commitment tree is
        </p>
        <div class="prelike">{{ noteResults.anchor }}</div>
        <p>
          Our proof that the note belongs to this tree consists of the following
          data:
        </p>
        <div class="prelike">{{ noteResults.proof }}</div>
        <p>
          We explain in the second part what these proof data are. For now,
          running the verification algorithm shows that we know a note in the
          note commitment tree.
        </p>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <h3>Verifier Input</h3>
      </v-col>
      <v-col cols="12">
        <v-form ref="verifyForm" v-model="verifyFormValid">
          <v-text-field
            v-model="verifyData.anchor"
            :counter="66"
            :rules="anchorRules"
            label="anchor"
            required
          ></v-text-field>
          <v-text-field
            v-model="verifyData.proof.a"
            :counter="98"
            :rules="proofARules"
            label="proof point a"
            required
          ></v-text-field>
          <v-textarea
            v-model="verifyData.proof.b"
            :counter="194"
            :rules="proofBRules"
            label="proof point b"
            rows="2"
            required
          ></v-textarea>
          <v-text-field
            v-model="verifyData.proof.c"
            :counter="98"
            :rules="proofCRules"
            label="proof point c"
            required
          ></v-text-field>
        </v-form>
      </v-col>
      <v-col cols="12">
        <v-btn
          outlined
          :disabled="!verifyFormValid"
          color="success"
          class="mr-4"
          @click="verifyProof"
          >Verify Proof</v-btn
        >
      </v-col>
      <v-col cols="12" class="caption">
        You can also manipulate the input data of the verifier and see the
        effect on the result. E.g., changing the anchor leads to a failing
        verification. Often you'll generate hex strings that are invalid
        representations of the required data, e.g. that the proof elements do
        not lie on the (subgroup of the) elliptic curve in play.
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <div>
          <v-alert
            :type="resultType()"
            border="left"
            elevation="2"
            colored-border
          >
            Result: {{ verifyResults }}</v-alert
          >
        </div>
      </v-col>
    </v-row>
    <v-row v-if="errorMessage">
      <v-col>
        <h3>Can't reach server</h3>
        <p>
          Please try again later.
          {{ errorMessage }}
        </p>
      </v-col>
    </v-row>
  </div>
</template>
<script>
const axios = require("axios");

let hexValidationWithLength = function (value, length, name) {
  var re = new RegExp(`^0x([0-9A-Fa-f]{${length}})$`, "g");
  return (
    re.test(value) ||
    `${name} has to be a 0x prefixed hex string of length ${length}`
  );
};

export default {
  props: ["noteResults"],
  data: function () {
    return {
      verifyData: {
        anchor: this.noteResults.anchor,
        nf: this.noteResults.nf,
        proof: this.noteResults.proof,
        cv: this.noteResults.cv,
        rk: this.noteResults.rk,
      },

      verifyFormValid: false,
      loadComplete: false,

      anchorRules: [
        (v) => {
          return hexValidationWithLength(v, 64, "anchor");
        },
      ],
      proofARules: [
        (v) => {
          return hexValidationWithLength(v, 96, "proof point a");
        },
      ],
      proofBRules: [
        (v) => {
          return hexValidationWithLength(v, 192, "proof point b");
        },
      ],
      proofCRules: [
        (v) => {
          return hexValidationWithLength(v, 96, "proof point c");
        },
      ],

      verifyResults: "Press 'Verify Proof' :-)",
    };
  },
  methods: {
    resultType: function () {
      return this.verifyResults == "true" ? "success" : "error";
    },
    verifyProof: function () {
      this.loadComplete = false;
      this.errorMessage = null;
      axios
        .post(
          process.env.VUE_APP_SNARK_INTRO_SERVER + "verify_proof",
          this.verifyData
        )
        .then((response) => {
          this.verifyResults = response.data.verify_result;

          this.loadComplete = true;
        })
        .catch((error) => {
          // handle error
          this.errorMessage = error;
          console.log(error);
        });
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
